#include <stdio.h>

/*********************************************/
/* Programmis kasutatud funktsioonide kirjeldus */
void shellSort(int a[], int size);
int increment(int inc[], int size);
/*********************************************/
int main () /*Peafunktsiooni kirjeldus*/
{
 int j;  
 int m=0;                /* Lokaal muutujate kirjeldus */
 int in_mas[100]; 

 /* Massiivi sisestus */
 printf("\nSisestage elementide arv massiivis: ");
 scanf("%d", &m); /* M22ran massiivi suurust */

 for(j = 0; j < m; j++) 
	{
  printf("\nSisestage arv number %d: ", j);
  scanf("%d", &in_mas[j]); /* Massiivi t2itmine */
        }
	if(j==0)
	{
		printf("\nEi ole mitte midagi sorteerimiseks!!!"); 
	}
	else
	{                                 /*Peafunktsioonis kutsun v2lja*/
	shellSort(in_mas, m);      /*funktsiooni, mis sorteerib Shelli meetodiga*/
	}		
				    
 printf ("\n");
 printf ("\n");
}
/*********************************************/
/* Shelli sorteerimise meetodi funktsiooni v2lja kutsutamine */
void shellSort(int a[], int size) 
{
 int inc, i, j, seq[40];          /*funktsiooni muutujaid*/
 int s;
	int jatkamine;
/* Juurde kasvu jada arvutamine */
/*selleks kutsun vj2lja abifunktsiooni increment()*/
 s = increment(seq, size);               
 while (s >= 0)
	{
  /* Sorteerimine juurde lisadega inkrementiga inc[]  */
  inc = seq[s--];

  for (i = inc; i < size; i++) 
	{
		int temp = a[i];
		for (j = i-inc; (j >= 0) && (a[j] > temp); j -= inc) 
			{
				a[j+inc] = a[j];
			}
		a[j+inc] = temp;
	}
      printf("\nJarjestatud rea: ");                 /*Jarjestatud massiivi trykimine*/
		for (i=0;i<size;i++)
		{
			printf("%d ", a[i]);
		}
		printf("\nJatkamiseks sisestage 1, lahkumiseks kl6psutage suvalist nuppu:\n ");
		scanf("%d", &jatkamine);
		switch(jatkamine)             /*siin teeme vali mida teha edasi*/
			{
				case 1:
				{
			        main();
				break;
				}
				case 2:
				{
				break;
				}
			}
	}
}
/*********************************************/
/* Abifunktsiooni kirjeldamine
   arvutan juurde kasvu jada */
int increment(int inc[], int size) 
	{
 int p1, p2, p3, s;

 p1 = p2 = p3 = 1;
 s = -1;
 do {
  if (++s % 2) {                   /*Kui massiivis on paaris elementide arv kasutan*/
   inc[s] = 8*p1 - 6*p2 + 1;    /*seda valemit, et teada incrementide arv*/
  }
  else {                              /*Kui massiivis on paaritu elementide arv*/
   inc[s] = 9*p1 - 9*p3 + 1;
   p2 *= 2;
   p3 *= 2;
  }
  p1 *= 2;
 }
 while(3*inc[s] < size);  

 return s > 0 ? --s : 0;        /*Vastavalt selele, missugune on s-i v22rtus */
				       /*tagastan kas --s v6i 0*/
}

